<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 27/04/17
 * Time: 15:47
 */

namespace Controller;

use Util\Utilities;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class Operador{

    /**
     * @var \Service\Operador
     */
    private $operadorService;

    public function __construct(\Service\Operador $operadorService) {
        $this->operadorService = $operadorService;
    }

    public function findAvailableCliente(Request\Filter $request, Response $response){
        try{
            $condition = $request->getFilterCriteria()->getConditions();
            $dataSet = $this->operadorService->findAvailableCliente($condition);
            $response->addDataSet(new DataSet('findAvailableCliente', $dataSet));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }

    public function findAllAvailableCliente(Request\Filter $request, Response $response){
        try{
            $condition = $request->getFilterCriteria()->getConditions();
            $dataSet = $this->operadorService->findAllAvailableCliente($condition);
            $response->addDataSet(new DataSet('findAvailableCliente', $dataSet));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }

    public function currentCliente(Request\Filter $request, Response $response){
        try{
            $dataSet = $this->operadorService->currentCliente();
            $response->addDataSet(new DataSet('currentCliente', $dataSet));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }

    public function saveCurrentCliente(Request\DataSet $request, Response $response){
        try{
            $row = $request->getDataSet()->getRows()[0];
            $cdcliente = $row['NRORG'];
            $this->operadorService->saveCurrentCliente($cdcliente);
        } catch (CustomException $e) {
            $response->setError(Utilities::getErrorObjectFromException($e));
        }
    }


}