<?php


namespace Controller;


use Zeedhi\Framework\DependencyInjection\InstanceManager;

class Organization
{
    public function organizationInactive(){
        ini_set("memory_limit", "1024M");
        ini_set('max_execution_time', '360000');
        set_time_limit(360000);
        /** @var \Service\Organization $organizationService */
        $organizationService = InstanceManager::getInstance()->getService('\Service\Organization');
        echo "Starting Inactive Organization!\n";
        $start = microtime(true);
        try{
            $organizationService->removeImportationOrganization();
            $organizationService->setAllOrganization();
            $organizationService->removeImportationWithoutDataSource();
        }catch (\Exception $e){
            echo $e->getMessage();
            throw $e;
        }
        $end = microtime(true);
        $total = $end - $start;
        echo("Done Inactive Organization!\n Tempo = $total\n");
    }
    public function findAll(\Zeedhi\Framework\DTO\Request\Filter $request, \Zeedhi\Framework\DTO\Response $response){
        try {
            $filters = $request->getFilterCriteria()->getConditions();
            $page = $request->getFilterCriteria()->getPage();
            $pageSize = $request->getFilterCriteria()->getPageSize();
            $orderBy = $request->getFilterCriteria()->getOrderBy();
            $isPrimary =  \Util\Utilities::getValueInFilterDataSourceByName($filters, 'IS_PRIMARY', true);

            /** @var \Service\Organization $organizationService */
            $organizationService = InstanceManager::getInstance()->getService('\Service\Organization');
            $organizations = $organizationService->findAll($filters, $page, $pageSize, $orderBy, null, $isPrimary);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('allOrganizations', $organizations));
        } catch (\Exception $ex){
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }
}