<?php
namespace Service\Manager\Mongo\Types;


class IdType extends Type {

	public function convertToDatabaseValue($value) {
		if ($value === null) {
			return null;
		}
		if (!$value instanceof \MongoDB\BSON\ObjectId) {
            try {
				$value = new \MongoDB\BSON\ObjectId($value);
			} catch (\MongoException $e) {
				$value = new \MongoDB\BSON\ObjectId();
			}
		}
		return $value;
	}

	public function convertToPHPValue($value) {
		return $value instanceof \MongoDB\BSON\ObjectId ? (string)$value : $value;
	}
}