/*@C:\Web_511\Sql\End_Conv\SQLSERVER\02DC_GERTRGS_LOG_CTB_LANCCONT.SQL*/
/* Tabela LANCCONT: Lancamentos Contabeis */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela LANCCONT */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Lancamentos Contabeis,
             utilizando a tabela Geral de Logs de Operaes */

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'LOG_CTB_LANCCONT' and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
   DROP TRIGGER LOG_CTB_LANCCONT
GO

CREATE TRIGGER LOG_CTB_LANCCONT
ON LANCCONT
AFTER DELETE, INSERT, UPDATE
AS
DECLARE  @V_USUARIO         VARCHAR(40);
DECLARE  @V_TIPO            VARCHAR(01);
DECLARE  @V_ITPESQ          VARCHAR(40);
DECLARE  @V_DESC            VARCHAR(300);
DECLARE  @V_DTOPER          DATETIME;
DECLARE  @V_DSREMOTEADDR    VARCHAR(15);
DECLARE  @V_DSREMOTEHOST    VARCHAR(15);
DECLARE  @V_DSSERVERRDM     VARCHAR(20);
DECLARE  @V_DSSERVMETHOD    VARCHAR(30);
DECLARE  @V_DSREMOTEOPER    VARCHAR(12);

/* COMEO DE DECLARAO DAS VARIVEIS A SEREM USADAS NO CURSOR */

DECLARE  @V_TIPOCOMANDO     VARCHAR(01);

DECLARE  @V_OLDCDCONTCTBL   VARCHAR(20);
DECLARE  @V_OLDCDHISTPADR   VARCHAR(04);
DECLARE  @V_OLDDTLANCCONT   DATETIME   ;
DECLARE  @V_OLDCDDOCUCONT   VARCHAR(20);
DECLARE  @V_OLDVRLANCAMENT  DOUBLE PRECISION;
DECLARE  @V_OLDCDCONTCOME   VARCHAR(21);
DECLARE  @V_OLDNRSEQLANC    VARCHAR(12);
DECLARE  @V_OLDCDEMPRESA    VARCHAR(02);

DECLARE  @V_NEWCDCONTCTBL   VARCHAR(20);
DECLARE  @V_NEWCDHISTPADR   VARCHAR(04);
DECLARE  @V_NEWDTLANCCONT   DATETIME;
DECLARE  @V_NEWCDDOCUCONT   VARCHAR(20);
DECLARE  @V_NEWVRLANCAMENT  DOUBLE PRECISION;
DECLARE  @V_NEWCDCONTCOME   VARCHAR(21);
DECLARE  @V_NEWCDEMPRESA    VARCHAR(02);
DECLARE  @V_NEWNRLANCCONT   VARCHAR(12);
DECLARE  @V_NEWNRSEQLANC    VARCHAR(05);

/*TRMINO DE DECLARAO DE VARIVEIS A SEREM USADAS NO CURSOR */

BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '' ;

   DECLARE C_CURSOR CURSOR FOR
   SELECT 'D', DEL.CDCONTCTBL, DEL.CDHISTPADR, DEL.DTLANCCONT, DEL.CDDOCUCONT,
               DEL.VRLANCAMENT, DEL.CDCONTCOME, DEL.NRSEQLANC, DEL.CDEMPRESA,

               NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL
     FROM
      DELETED DEL
    WHERE
      CDEMPRESA+NRLANCCONT+NRSEQLANC NOT IN (SELECT CDEMPRESA+NRLANCCONT+NRSEQLANC FROM INSERTED)
   /***********************************************************************************/
   /* AQUI E PASSADO NULL.POIS CURSOR DEVER TER A MESMA ESTRUTURA DE TODOS SELECTS    */
   /* COMO A ESTRUTURA DO SELECT DESTE CURSOR  DE NA PARTE DE CIMA, FICAR OS         */
   /* OLD VALUES, (VALORES DELETADOS). SER PASSADO NULL PARA A PARTE DE BAIXO        */
   /* (REFERENTE AOS NEW VALUES) QUE MAIS ABAIXO SER FEITO O PREENCHIMENTO           */
   /* DOS MESMOS, EM UPDATE OU INSERT.                                                */
   /* PS: ESTRUTURA  O NMERO DE COLUNAS E TIPOS E TAMANHOS DOS CAMPOS A             */
   /* SEREM RETORNADOS NO SELECT                                                      */
   /***********************************************************************************/

   UNION ALL
   /* PARTE DO UPDATED */
   SELECT 'U', DEL.CDCONTCTBL, DEL.CDHISTPADR, DEL.DTLANCCONT, DEL.CDDOCUCONT,
               DEL.VRLANCAMENT, DEL.CDCONTCOME, DEL.NRSEQLANC, DEL.CDEMPRESA,

               INS.CDCONTCTBL, INS.CDHISTPADR, INS.DTLANCCONT, INS.CDDOCUCONT,
               INS.VRLANCAMENT, INS.CDCONTCOME, INS.CDEMPRESA, INS.NRLANCCONT,
               INS.NRSEQLANC
     FROM
        INSERTED INS, DELETED DEL
    WHERE
        INS.CDEMPRESA  = DEL.CDEMPRESA  AND
        INS.NRLANCCONT = DEL.NRLANCCONT AND
        INS.NRSEQLANC  = DEL.NRSEQLANC
   /**********************************************************************/
   /* Aqui  feito a comparao das tabelas de deleted e inserted        */
   /* Pois se um registro complementar "antigo" foi apagado e um novo    */
   /* foi inserido em seu lugar, permanecendo as primarys keys nativas,  */
   /* isto indica um update                                              */
   /**********************************************************************/

    UNION ALL
    /* PARTE DO INSERTED */
    SELECT 'I', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,

              INS.CDCONTCTBL, INS.CDHISTPADR, INS.DTLANCCONT, INS.CDDOCUCONT,
              INS.VRLANCAMENT, INS.CDCONTCOME, INS.CDEMPRESA, INS.NRLANCCONT,
              INS.NRSEQLANC
      FROM
         INSERTED INS
     WHERE
         CDEMPRESA+NRLANCCONT+NRSEQLANC NOT IN (SELECT CDEMPRESA+NRLANCCONT+NRSEQLANC FROM DELETED)
  /*******************************************************/
  /* Preenchimento dos New Values, como foi dito acima.  */
  /* Sempre obedecendo a estrutura, pois de acordo com a */
  /* Ordem dos resultados, que ir ser feita a alocao  */
  /* de valores nas respectivas variveis.               */
  /*******************************************************/

   OPEN C_CURSOR;

   FETCH NEXT FROM C_CURSOR INTO  @V_TIPOCOMANDO, @V_OLDCDCONTCTBL, @V_OLDCDHISTPADR,
                                  @V_OLDDTLANCCONT, @V_OLDCDDOCUCONT, @V_OLDVRLANCAMENT,
                                  @V_OLDCDCONTCOME, @V_OLDNRSEQLANC, @V_OLDCDEMPRESA,

                                  @V_NEWCDCONTCTBL, @V_NEWCDHISTPADR, @V_NEWDTLANCCONT,
                                  @V_NEWCDDOCUCONT, @V_NEWVRLANCAMENT, @V_NEWCDCONTCOME,
                                  @V_NEWCDEMPRESA, @V_NEWNRLANCCONT, @V_NEWNRSEQLANC
   /***************************************************/
   /* Aqui ser feito o preenchimento das variveis   */
   /* de acordo com o retorno dos selects acima. Como */
   /* foi dito, os selects devem obedecer a mesma     */
   /* estrutura. Para posteriormente, os valores das  */
   /* variveis se encaixarem corretamente, quando o  */
   /* ponteiro do cursor passar para a prxima linha  */
   /* utilizando o fetch next. Toda vez que o cursor  */
   /* for aberto, ir trazer os resultados de acordo  */
   /* com seu contedo. No caso, os selects.          */
   /* A clusula INTO depois do fetch next, funciona  */
   /* como um "insert into (....), mas usando a linha */
   /* posicionada do cursor como referncia para arma-*/
   /*zenamento de valores em variveis.               */
   /***************************************************/

   WHILE (@@FETCH_STATUS = 0) BEGIN
      /**************************************************************/
      /*@@fetch status = 0 verifica se a mudana de linha do cursor */
      /*com a aplicao do bloco de comandos foi feita com sucesso. */
      /**************************************************************/

      SET @V_DESC   = '';
      SET @V_ITPESQ = '';
      IF (@V_TIPOCOMANDO = 'D') BEGIN
         IF @V_OLDCDCONTCTBL IS NOT NULL BEGIN
            SET @V_DESC = (@V_DESC + 'ContCtbl=' + @V_OLDCDCONTCTBL);
         END;

         IF @V_OLDCDHISTPADR IS NOT NULL BEGIN
            SET @V_DESC = (@V_DESC + ' Historico=' + @V_OLDCDHISTPADR);
         END;

         IF @V_OLDDTLANCCONT IS NOT NULL BEGIN
            SET @V_DESC = (@V_DESC + ' Data=' + CONVERT(VARCHAR, @V_OLDDTLANCCONT, 103));
         END;

         IF @V_OLDCDDOCUCONT IS NOT NULL BEGIN
            SET @V_DESC = (@V_DESC + ' Documento=' + @V_OLDCDDOCUCONT);
         END;

         IF @V_OLDVRLANCAMENT IS NOT NULL BEGIN
            SET @V_DESC = (@V_DESC + ' Valor=' + CONVERT(VARCHAR, ROUND(@V_OLDVRLANCAMENT, 5)));
         END;

         IF @V_OLDCDCONTCOME IS NOT NULL BEGIN
            SET @V_DESC = (@V_DESC + ' ContaComercial=' + @V_OLDCDCONTCOME);
         END
         ELSE BEGIN
            SET @V_OLDCDCONTCOME = '';
         END;

         SET @V_TIPO   = '3';
         SET @V_ITPESQ = (@V_OLDCDEMPRESA+@V_OLDCDCONTCOME+@V_OLDNRSEQLANC);

      END
      ELSE IF (@V_TIPOCOMANDO = 'U') BEGIN
         IF (@V_NEWCDCONTCTBL  <> @V_OLDCDCONTCTBL) OR
            (@V_NEWCDHISTPADR  <> @V_OLDCDHISTPADR) OR
            (@V_NEWDTLANCCONT  <> @V_OLDDTLANCCONT) OR
            (@V_NEWCDDOCUCONT  <> @V_OLDCDDOCUCONT) OR
            (@V_NEWVRLANCAMENT <> @V_OLDVRLANCAMENT) OR
            (@V_NEWCDCONTCOME  <> @V_OLDCDCONTCOME) BEGIN

            SET @V_TIPO         = '2';
            SET @V_ITPESQ       = @V_NEWCDEMPRESA+@V_NEWNRLANCCONT+@V_NEWNRSEQLANC;
         END;
      END
      ELSE BEGIN
         SET @V_TIPO         = '1';
         SET @V_ITPESQ       = @V_NEWCDEMPRESA+@V_NEWNRLANCCONT+@V_NEWNRSEQLANC;
      END;

      IF @V_NEWCDCONTCTBL IS NOT NULL BEGIN
         SET @V_DESC = (@V_DESC + 'ContCtbl=' + @V_NEWCDCONTCTBL);
      END;

      IF @V_NEWCDHISTPADR IS NOT NULL BEGIN
         SET @V_DESC = (@V_DESC + ' Historico=' + @V_NEWCDHISTPADR);
      END;

      IF @V_NEWDTLANCCONT IS NOT NULL BEGIN
         SET @V_DESC = (@V_DESC + ' Data=' + CONVERT(VARCHAR, @V_NEWDTLANCCONT, 103));
      END;

      IF @V_NEWCDDOCUCONT IS NOT NULL BEGIN
         SET @V_DESC = (@V_DESC + ' Documento=' + @V_NEWCDDOCUCONT);
      END;

      IF @V_NEWVRLANCAMENT IS NOT NULL BEGIN
         SET @V_DESC = (@V_DESC + ' Valor=' + (CONVERT(VARCHAR, ROUND(@V_NEWVRLANCAMENT, 5))));
      END;

      IF @V_NEWCDCONTCOME IS NOT NULL BEGIN
         SET @V_DESC = (@V_DESC + ' ContaComercial=' + @V_NEWCDCONTCOME);
      END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO  @V_USUARIO;
         EXEC WEBTUNNING @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVERRDM,
                         @V_DSSERVMETHOD, @V_DSREMOTEOPER;

         IF NOT @V_DESC IS NULL BEGIN
            SET @V_DTOPER = GETDATE();

            INSERT INTO LOGOPERA
               (NMTABELA,     DTOPERACAO, NMRESPOPER, IDTIPOOPER,   CDPESQITEM,   DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,  DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('LANCCONT', @V_DTOPER, ISNULL(@V_USUARIO, 'Sistema Teknisa'),
                @V_TIPO, @V_ITPESQ, @V_DESC, @V_DSSERVERRDM,  @V_DSREMOTEADDR,
                @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_DSREMOTEOPER);
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_TIPOCOMANDO, @V_OLDCDCONTCTBL, @V_OLDCDHISTPADR,
                                    @V_OLDDTLANCCONT, @V_OLDCDDOCUCONT, @V_OLDVRLANCAMENT,
                                    @V_OLDCDCONTCOME, @V_OLDNRSEQLANC, @V_OLDCDEMPRESA,

                                    @V_NEWCDCONTCTBL, @V_NEWCDHISTPADR, @V_NEWDTLANCCONT,
                                    @V_NEWCDDOCUCONT, @V_NEWVRLANCAMENT, @V_NEWCDCONTCOME,
                                    @V_NEWCDEMPRESA, @V_NEWNRLANCCONT, @V_NEWNRSEQLANC;

   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO